type t = { mutable year : int; mutable month : int; mutable day : int; }
type u = int * int * int
val to_string : t -> string
val make : u -> t
val unmake : t -> int * int * int
val set : t -> u -> unit
val get : t -> u
val ( *** ) : int -> int -> int
val compare : t -> t -> int
val is_leap : t -> bool
val month_lengths : int array
val month_length : int -> int -> int
val leap_month_lengths : int array
val increment : t -> unit
val decrement : t -> unit
val copy : t -> t
val today : unit -> t
val iter : u -> u -> (u -> unit) -> unit
