open Io;;

let io_toto = io_list (io_pair (io_pair io_int io_string) io_float);;
let toto1 =
  [
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
    ((33, "hello1"), 3.1419);
  ]
;;
let io_toto = io_list io_int;;
let toto1 =
  let rec loop n =
    if n > 0x1000000 then
      []
    else
      n :: (loop (n + 0x1277))
  in
  loop 0
;;

type selector = int;;
type reason =
| Not_available of int
| Requested of int
| Dependency of int * int list (*
| Empty_disjunction of int * (int * selector) list
| Conflict of int * int*)
;;


let io_reason =
  io_sum
    begin
      begin function
        | "not_available" -> fun i -> Not_available(read io_int i)
        | "requested"     -> fun i -> Requested(read io_int i)
        | "dependency"    ->
            fun i ->
              let (x,y) = read (io_pair io_int (io_list io_int)) i in
              Dependency(x,y)
        | _ -> raise Unknown_tag
      end,
      begin function
        | Not_available x -> "not_available", write io_int x
        | Requested x     -> "requested",     write io_int x
        | Dependency(x,y) -> "dependency",    write (io_pair io_int (io_list io_int)) (x,y)
      end
    end
;;

let print_human x =
  let z = Human_io.out_of_channel ~indent:true ~out_channel:stdout () in
  write io_toto x z;
  flush z
;;

let _ =
  match Sys.argv.(1) with
  | "l" ->
    let fn = Sys.argv.(2) in
    let z = Generic_io.load_from_file io_toto fn in
    print_human z
  | "wf" -> Generic_io.save_to_file io_toto toto1 Sys.argv.(2)
  | "wfb" -> Generic_io.save_to_file io_toto toto1 ~fmt:Generic_io.Bin Sys.argv.(2)
  | "wb" ->
      let ch = Binary_io.out_of_channel ~out_channel:stdout () in
      write io_toto toto1 ch;
      flush ch
  | "ws" ->
      let (ch, get) = Binary_io.out_to_string () in
      write io_toto toto1 ch;
      flush ch;
      let w = get () in
      Printf.printf "Encoded as %S\n%!" w
  | "wh" -> print_human toto1
  | "rh" ->
    let z = Human_io.in_of_channel ~in_channel:stdin () in
    let x = read io_toto z in
    print_human x
  | "rb" ->
    let z = Binary_io.in_of_channel ~in_channel:stdin () in
    let x = read io_toto z in
    print_human x
  | "h2b" ->
    let a = Human_io.in_of_channel ~in_channel:stdin () in
    let b = Binary_io.out_of_channel ~out_channel:stdout () in
    convert ~reader:a ~writer:b ()
  | "b2h" ->
    let a = Binary_io.in_of_channel ~in_channel:stdin () in
    let b = Human_io.out_of_channel ~indent:true ~out_channel:stdout () in
    convert ~reader:a ~writer:b ()
  | "dump" ->
    let z = Human_io.in_of_channel ~in_channel:stdin () in
    dump ~reader:z ()
  | _ -> Printf.printf "Say wh or rh.\n%!"
;;
