open Io;;

let io_toto = io_list (io_pair (io_triple (io_array io_int) io_int io_string) io_float);;
let toto1 =
  [
    (([|22;33;44;55|], 33, "hello1"), 3.1419);
    (([|22;33;44;55|], 33, "h\033\044\055\022\222ello1"), 3.1419);
    (([|22;33;44;55|], 33, "hello1"), 3.1419);
  ]
;;
(*let io_toto = io_list io_int;;
let toto1 =
  let rec loop n =
    if n > 0x1000000 then
      []
    else
      n :: (loop (n + 0x1277))
  in
  loop 0
;;*)

type selector = int;;
type reason =
| Not_available of int
| Requested of int
| Dependency of int * int list (*
| Empty_disjunction of int * (int * selector) list
| Conflict of int * int*)
;;

type diagnosis = {
  dg_closure_size : int;
  dg_conflicts : int;
  dg_disjunctions : int;
  dg_dependencies : int;
  dg_failures : (int * reason list) array
}
;;

let io_reason =
  io_sum
    begin
      begin function
        | "Not_available" -> fun i -> Not_available(read io_int i)
        | "Requested"     -> fun i -> Requested(read io_int i)
        | "Dependency"    ->
            fun i ->
              let (x,y) = read (io_pair io_int (io_list io_int)) i in
              Dependency(x,y)
        | _ -> raise Unknown_constructor
      end,
      begin function
        | Not_available x -> "Not_available", write io_int x
        | Requested x     -> "Requested",     write io_int x
        | Dependency(x,y) -> "Dependency",    write (io_pair io_int (io_list io_int)) (x,y)
      end
    end
;;

(*** default_diagnosis *)
let default_diagnosis = {
  dg_closure_size = 0;
  dg_conflicts = 0;
  dg_disjunctions = 0;
  dg_dependencies = 0;
  dg_failures = [||]
};;
let io_diagnosis =
  io_record
  [
    "closure_size",
      (fun x i -> { x with dg_closure_size = read io_int i }),
      (fun x -> write io_int x.dg_closure_size );
    "conflicts",
      (fun x i -> { x with dg_conflicts = read io_int i }),
      (fun x -> write io_int x.dg_conflicts);
    "disjunctions",
      (fun x i -> { x with dg_disjunctions = read io_int i }),
      (fun x -> write io_int x.dg_disjunctions);
    "dependencies",
      (fun x i -> { x with dg_dependencies = read io_int i }),
      (fun x -> write io_int x.dg_dependencies);
    let io = io_array (io_pair io_int (io_list io_reason)) in
    "failures",
      (fun x i -> { x with dg_failures = read io i }),
      (fun x -> write io x.dg_failures)
  ]
  default_diagnosis
;;
(* ***)

let toto1 = {
  dg_closure_size = 6666;
  dg_conflicts = 7777;
  dg_disjunctions = 3333;
  dg_dependencies = 2222;
  dg_failures = [|
    (12345, [Requested 666; Not_available 777]);
    (23456, [Dependency(123,[456;567;678])])
  |]
};;

let io_toto = io_diagnosis;;

let print_human x =
  let z = Human_io.out_of_channel ~indent:true ~out_channel:stdout () in
  write io_toto x z;
  flush z
;;

let _ =
  match Sys.argv.(1) with
  | "lf" ->
    let fn = Sys.argv.(2) in
    let z = Generic_io.load_from_file io_toto fn in
    print_human z
  | "wf" -> Generic_io.save_to_file io_toto toto1 ~fmt:Generic_io.Asc Sys.argv.(2)
  | "wfb" -> Generic_io.save_to_file io_toto toto1 ~fmt:Generic_io.Bin Sys.argv.(2)
  | "wb" ->
      let ch = Binary_io.out_of_channel ~out_channel:stdout () in
      write io_toto toto1 ch;
      flush ch
  | "ws" ->
      let (ch, get) = Binary_io.out_to_string () in
      write io_toto toto1 ch;
      flush ch;
      let w = get () in
      Printf.printf "Encoded as %S\n%!" w
  | "wh" -> print_human toto1
  | "rh" ->
    let z = Human_io.in_of_channel ~in_channel:stdin () in
    let x = read io_toto z in
    print_human x
  | "rb" ->
    let z = Binary_io.in_of_channel ~in_channel:stdin () in
    let x = read io_toto z in
    print_human x
  | "h2b" ->
    let a = Human_io.in_of_channel ~in_channel:stdin () in
    let b = Binary_io.out_of_channel ~out_channel:stdout () in
    convert ~reader:a ~writer:b ()
  | "b2h" ->
    let a = Binary_io.in_of_channel ~in_channel:stdin () in
    let b = Human_io.out_of_channel ~indent:true ~out_channel:stdout () in
    convert ~reader:a ~writer:b ()
  | "dump" ->
    let z = Human_io.in_of_channel ~in_channel:stdin () in
    dump ~reader:z ()
  | _ -> Printf.printf "Say wh or rh.\n%!"
;;
