(* Buffer_formatter *)
(* Copyright (C)2000-2006 Berke Durak                               *)
(* Released under the GNU Lesser General Public License version 2.1 *)

exception Limit_exceeded

(*** buffer_formatter *)
class buffer_formatter ?(limit=100000) () =
  let buffer = Buffer.create 1024 in
  object(self)
    val mutable fmt = Format.std_formatter
    initializer
      fmt <- Format.make_formatter self#output (fun () -> ())
    method private output w o l =
      let m = Buffer.length buffer in
      if m + l > limit then
        begin
          self#clear;
          raise Limit_exceeded
        end
      else
        Buffer.add_substring buffer w o l
    method clear =
      Format.fprintf fmt "@.";
      Buffer.clear buffer
    method formatter = fmt
    method get =
      Format.fprintf fmt "@.";
      Buffer.contents buffer
  end
;;
(* ***)
