(* Hex *)
(* Copyright (C)2000-2006 Berke Durak                               *)
(* Released under the GNU Lesser General Public License version 2.1 *)

let hex = "0123456789abcdef"

exception Error

let of_string s =
  let m = String.length s in
  let h = String.make (2 * m) '\000' in
  for i = 0 to m - 1 do
	let c = Char.code s.[i] in
	h.[2*i] <- hex.[c lsr 4];
	h.[2*i+1] <- hex.[c land 15]
  done;
  h

let lower_a_code = (Char.code 'a') - 10
let upper_a_code = (Char.code 'A') - 10

let int_of_digit c =
  let cc = Char.code c in
  match c with
	'0'..'9' -> cc land 15
  |	'a'..'f' -> cc - lower_a_code
  |	'A'..'F' -> cc - upper_a_code
  |	_ -> raise Error

let string_of h =
  let m = String.length h in
  if m mod 2 = 1 then
	raise Error;
  let s = String.make (m / 2) '\000' in
  for i = 0 to (m / 2) - 1 do
	s.[i] <- Char.chr (((int_of_digit h.[2*i]) lsl 4) + (int_of_digit h.[2*i + 1]))
  done;
  s
