(* Random_source *)
(* Copyright (C)2000-2006 Berke Durak                               *)
(* Released under the GNU Lesser General Public License version 2.1 *)

let device =
  try
    Sys.getenv "RANDOM_DEVICE"
  with
    Not_found -> "/dev/urandom"
;;
                  
let rf = open_in_bin device;;

let get_safe_byte () = input_byte rf;;

let get_safe_string m =
  let s = String.make m '\000' in
  if m <> input rf s 0 m then
    failwith ("Short read from device "^device)
  else
    s
;;
