(* Render *)
(* The EDOS project                                                 *)
(* Copyright (C)2000-2006 Berke Durak                               *)
(* Released under the GNU Lesser General Public License version 2.1 *)

let color_sequence = [|Rgb.red;Rgb.yellow;Rgb.green;Rgb.cyan;Rgb.blue;Rgb.magenta|];;
(*** make_row *)
let make_row ?(header=false) ?(color_sequence = color_sequence) l =
  let rec loop i res = function
    | [] -> res
    | head::rest ->
        let i' =
          if i + 1 < Array.length color_sequence then
            i + 1
          else
            0
        in
        loop i'
          ((C_color(color_sequence.(i),
            if header then
              C_header(C_contents head)
            else
              C_contents head))::res)
            rest
  in
  List.rev (loop 0 [] l)
;;
(* ***)
